aboutsummaryrefslogtreecommitdiffhomepage
diff options
context:
space:
mode:
-rw-r--r--BUILD.public129
-rw-r--r--LICENSE206
-rwxr-xr-xtools/create_skia_google3_client.sh24
-rwxr-xr-xtools/get_skia_lkgr.sh23
-rwxr-xr-xtools/git_clone_to_google3.sh94
-rwxr-xr-xtools/sync_google3.sh43
6 files changed, 519 insertions, 0 deletions
diff --git a/BUILD.public b/BUILD.public
new file mode 100644
index 0000000000..f69e9b63c1
--- /dev/null
+++ b/BUILD.public
@@ -0,0 +1,129 @@
+# Description:
+# Skia graphics library.
+#
+# Definitions for Google BUILD file.
+
+exports_files(["BUILD.public"])
+
+# Platform-independent SRCS
+SRCS = glob(
+ [
+ "google/*.cpp",
+ "src/c/*.cpp",
+ "src/core/*.cpp",
+ "src/device/*.cpp",
+ "src/doc/*.cpp",
+ "src/effects/*.cpp",
+ "src/effects/gradients/*.cpp",
+ "src/image/*.cpp",
+ "src/images/*.cpp",
+ "src/lazy/*.cpp",
+ "src/pathops/*.cpp",
+ "src/pdf/*.cpp",
+ "src/pipe/*.cpp",
+ "src/sfnt/*.cpp",
+ "src/utils/*.cpp",
+ "src/gpu/*.cpp",
+ "src/gpu/effects/*.cpp",
+ "src/gpu/gl/*.cpp",
+ "src/gpu/gl/builders/*.cpp",
+ "src/gpu/gl/debug/*.cpp",
+ "src/gpu/gl/glx/*.cpp",
+ "src/opts/opts_check_x86.cpp",
+ "src/opts/*SSE2*.cpp",
+ "src/opts/SkTextureCompression_opts_none.cpp",
+
+ # TODO(mtklein): might be more maintainable with a blacklist instead?
+ "src/ports/SkBarriers_x86.cpp",
+ "src/ports/SkDebug_stdio.cpp",
+ "src/ports/SkDiscardableMemory_none.cpp",
+ "src/ports/SkFontHost_linux.cpp",
+ "src/ports/SkFontHost_FreeType.cpp",
+ "src/ports/SkFontHost_FreeType_common.cpp",
+ "src/ports/SkGlobalInitialization_default.cpp",
+ "src/ports/SkImageGenerator_skia.cpp",
+ "src/ports/SkMemory_malloc.cpp",
+ "src/ports/SkMutex_pthread.h",
+ "src/ports/SkOSFile_posix.cpp",
+ "src/ports/SkOSFile_stdio.cpp",
+ "src/ports/SkTLS_pthread.cpp",
+ "src/ports/SkTime_Unix.cpp",
+
+ # Third Party
+ "third_party/etc1/*.cpp",
+ "third_party/ktx/*.cpp",
+ ],
+ exclude = [
+ "src/pdf/SkPDFFont.cpp", # Wrapped by google/SkPDFFont_sfntly.cpp
+ "src/gpu/gl/GrGLDefaultInterface_none.cpp",
+ "src/gpu/gl/GrGLCreateNativeInterface_none.cpp",
+ # TODO(mtklein): files below here probably want upstream fixes
+ "src/utils/SkThreadUtils_pthread_mach.cpp", # Mac-only. Move to ports?
+ # Non-Mac-non-Linux. Move to ports?
+ "src/utils/SkThreadUtils_pthread_other.cpp",
+ "src/utils/SkThreadUtils_win.cpp", # Windows-only. Move to ports?
+ "src/doc/*_XPS.cpp",
+
+ # TODO(melanielc): These don't compile. Maybe remove them?
+ "src/pathops/SkConicLineIntersection.cpp",
+ "src/pathops/SkPathOpsPostSect.cpp",
+ ],
+)
+
+HDRS = glob(
+ [
+ "include/**/*.h",
+ ],
+)
+
+# Includes needed by Skia implementation. Not public includes.
+INCLUDES = [
+ "include/animator",
+ "include/c",
+ "include/codec",
+ "include/config",
+ "include/core",
+ "include/device",
+ "include/effects",
+ "include/gpu",
+ "include/images",
+ "include/pathops",
+ "include/pdf",
+ "include/pipe",
+ "include/ports",
+ "include/private",
+ "include/utils",
+ "include/views",
+ "include/xml",
+ "src/core",
+ "src/doc",
+ "src/gpu",
+ "src/image",
+ "src/lazy",
+ "src/opts",
+ "src/pdf",
+ "src/ports",
+ "src/sfnt",
+ "src/utils",
+ "third_party/etc1",
+ "third_party/ktx",
+]
+
+COPTS = [
+ "-Wno-deprecated-declarations", # Internal use of deprecated methods. :(
+ "-Wno-implicit-fallthrough", # Some intentional fallthrough.
+]
+
+DEFINES = [
+ # It'd be nice for fastbuild, dbg -> SK_DEBUG, opt -> SK_RELEASE.
+ "SK_RELEASE",
+ # Chrome DEFINES.
+ "SK_USE_FLOATBITS",
+ "SK_USE_FREETYPE_EMBOLDEN",
+ # Turn on a few Google3-specific build fixes.
+ "GOOGLE3",
+ "SK_BUILD_FOR_UNIX",
+ "SK_SAMPLES_FOR_X",
+]
+
+LINKOPTS = ["-ldl"]
diff --git a/LICENSE b/LICENSE
index e74c256cba..e97437da52 100644
--- a/LICENSE
+++ b/LICENSE
@@ -25,3 +25,209 @@
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+--------------------------------------------------------------------------------
+third_party/etc1 is under the following license:
+
+
+ Apache License
+ Version 2.0, January 2004
+ http://www.apache.org/licenses/
+
+ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
+
+ 1. Definitions.
+
+ "License" shall mean the terms and conditions for use, reproduction,
+ and distribution as defined by Sections 1 through 9 of this document.
+
+ "Licensor" shall mean the copyright owner or entity authorized by
+ the copyright owner that is granting the License.
+
+ "Legal Entity" shall mean the union of the acting entity and all
+ other entities that control, are controlled by, or are under common
+ control with that entity. For the purposes of this definition,
+ "control" means (i) the power, direct or indirect, to cause the
+ direction or management of such entity, whether by contract or
+ otherwise, or (ii) ownership of fifty percent (50%) or more of the
+ outstanding shares, or (iii) beneficial ownership of such entity.
+
+ "You" (or "Your") shall mean an individual or Legal Entity
+ exercising permissions granted by this License.
+
+ "Source" form shall mean the preferred form for making modifications,
+ including but not limited to software source code, documentation
+ source, and configuration files.
+
+ "Object" form shall mean any form resulting from mechanical
+ transformation or translation of a Source form, including but
+ not limited to compiled object code, generated documentation,
+ and conversions to other media types.
+
+ "Work" shall mean the work of authorship, whether in Source or
+ Object form, made available under the License, as indicated by a
+ copyright notice that is included in or attached to the work
+ (an example is provided in the Appendix below).
+
+ "Derivative Works" shall mean any work, whether in Source or Object
+ form, that is based on (or derived from) the Work and for which the
+ editorial revisions, annotations, elaborations, or other modifications
+ represent, as a whole, an original work of authorship. For the purposes
+ of this License, Derivative Works shall not include works that remain
+ separable from, or merely link (or bind by name) to the interfaces of,
+ the Work and Derivative Works thereof.
+
+ "Contribution" shall mean any work of authorship, including
+ the original version of the Work and any modifications or additions
+ to that Work or Derivative Works thereof, that is intentionally
+ submitted to Licensor for inclusion in the Work by the copyright owner
+ or by an individual or Legal Entity authorized to submit on behalf of
+ the copyright owner. For the purposes of this definition, "submitted"
+ means any form of electronic, verbal, or written communication sent
+ to the Licensor or its representatives, including but not limited to
+ communication on electronic mailing lists, source code control systems,
+ and issue tracking systems that are managed by, or on behalf of, the
+ Licensor for the purpose of discussing and improving the Work, but
+ excluding communication that is conspicuously marked or otherwise
+ designated in writing by the copyright owner as "Not a Contribution."
+
+ "Contributor" shall mean Licensor and any individual or Legal Entity
+ on behalf of whom a Contribution has been received by Licensor and
+ subsequently incorporated within the Work.
+
+ 2. Grant of Copyright License. Subject to the terms and conditions of
+ this License, each Contributor hereby grants to You a perpetual,
+ worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+ copyright license to reproduce, prepare Derivative Works of,
+ publicly display, publicly perform, sublicense, and distribute the
+ Work and such Derivative Works in Source or Object form.
+
+ 3. Grant of Patent License. Subject to the terms and conditions of
+ this License, each Contributor hereby grants to You a perpetual,
+ worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+ (except as stated in this section) patent license to make, have made,
+ use, offer to sell, sell, import, and otherwise transfer the Work,
+ where such license applies only to those patent claims licensable
+ by such Contributor that are necessarily infringed by their
+ Contribution(s) alone or by combination of their Contribution(s)
+ with the Work to which such Contribution(s) was submitted. If You
+ institute patent litigation against any entity (including a
+ cross-claim or counterclaim in a lawsuit) alleging that the Work
+ or a Contribution incorporated within the Work constitutes direct
+ or contributory patent infringement, then any patent licenses
+ granted to You under this License for that Work shall terminate
+ as of the date such litigation is filed.
+
+ 4. Redistribution. You may reproduce and distribute copies of the
+ Work or Derivative Works thereof in any medium, with or without
+ modifications, and in Source or Object form, provided that You
+ meet the following conditions:
+
+ (a) You must give any other recipients of the Work or
+ Derivative Works a copy of this License; and
+
+ (b) You must cause any modified files to carry prominent notices
+ stating that You changed the files; and
+
+ (c) You must retain, in the Source form of any Derivative Works
+ that You distribute, all copyright, patent, trademark, and
+ attribution notices from the Source form of the Work,
+ excluding those notices that do not pertain to any part of
+ the Derivative Works; and
+
+ (d) If the Work includes a "NOTICE" text file as part of its
+ distribution, then any Derivative Works that You distribute must
+ include a readable copy of the attribution notices contained
+ within such NOTICE file, excluding those notices that do not
+ pertain to any part of the Derivative Works, in at least one
+ of the following places: within a NOTICE text file distributed
+ as part of the Derivative Works; within the Source form or
+ documentation, if provided along with the Derivative Works; or,
+ within a display generated by the Derivative Works, if and
+ wherever such third-party notices normally appear. The contents
+ of the NOTICE file are for informational purposes only and
+ do not modify the License. You may add Your own attribution
+ notices within Derivative Works that You distribute, alongside
+ or as an addendum to the NOTICE text from the Work, provided
+ that such additional attribution notices cannot be construed
+ as modifying the License.
+
+ You may add Your own copyright statement to Your modifications and
+ may provide additional or different license terms and conditions
+ for use, reproduction, or distribution of Your modifications, or
+ for any such Derivative Works as a whole, provided Your use,
+ reproduction, and distribution of the Work otherwise complies with
+ the conditions stated in this License.
+
+ 5. Submission of Contributions. Unless You explicitly state otherwise,
+ any Contribution intentionally submitted for inclusion in the Work
+ by You to the Licensor shall be under the terms and conditions of
+ this License, without any additional terms or conditions.
+ Notwithstanding the above, nothing herein shall supersede or modify
+ the terms of any separate license agreement you may have executed
+ with Licensor regarding such Contributions.
+
+ 6. Trademarks. This License does not grant permission to use the trade
+ names, trademarks, service marks, or product names of the Licensor,
+ except as required for reasonable and customary use in describing the
+ origin of the Work and reproducing the content of the NOTICE file.
+
+ 7. Disclaimer of Warranty. Unless required by applicable law or
+ agreed to in writing, Licensor provides the Work (and each
+ Contributor provides its Contributions) on an "AS IS" BASIS,
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+ implied, including, without limitation, any warranties or conditions
+ of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
+ PARTICULAR PURPOSE. You are solely responsible for determining the
+ appropriateness of using or redistributing the Work and assume any
+ risks associated with Your exercise of permissions under this License.
+
+ 8. Limitation of Liability. In no event and under no legal theory,
+ whether in tort (including negligence), contract, or otherwise,
+ unless required by applicable law (such as deliberate and grossly
+ negligent acts) or agreed to in writing, shall any Contributor be
+ liable to You for damages, including any direct, indirect, special,
+ incidental, or consequential damages of any character arising as a
+ result of this License or out of the use or inability to use the
+ Work (including but not limited to damages for loss of goodwill,
+ work stoppage, computer failure or malfunction, or any and all
+ other commercial damages or losses), even if such Contributor
+ has been advised of the possibility of such damages.
+
+ 9. Accepting Warranty or Additional Liability. While redistributing
+ the Work or Derivative Works thereof, You may choose to offer,
+ and charge a fee for, acceptance of support, warranty, indemnity,
+ or other liability obligations and/or rights consistent with this
+ License. However, in accepting such obligations, You may act only
+ on Your own behalf and on Your sole responsibility, not on behalf
+ of any other Contributor, and only if You agree to indemnify,
+ defend, and hold each Contributor harmless for any liability
+ incurred by, or claims asserted against, such Contributor by reason
+ of your accepting any such warranty or additional liability.
+
+ END OF TERMS AND CONDITIONS
+
+ APPENDIX: How to apply the Apache License to your work.
+
+ To apply the Apache License to your work, attach the following
+ boilerplate notice, with the fields enclosed by brackets "[]"
+ replaced with your own identifying information. (Don't include
+ the brackets!) The text should be enclosed in the appropriate
+ comment syntax for the file format. We also recommend that a
+ file or class name and description of purpose be included on the
+ same "printed page" as the copyright notice for easier
+ identification within third-party archives.
+
+ Copyright [yyyy] [name of copyright owner]
+
+ Licensed under the Apache License, Version 2.0 (the "License");
+ you may not use this file except in compliance with the License.
+ You may obtain a copy of the License at
+
+ http://www.apache.org/licenses/LICENSE-2.0
+
+ Unless required by applicable law or agreed to in writing, software
+ distributed under the License is distributed on an "AS IS" BASIS,
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ See the License for the specific language governing permissions and
+ limitations under the License.
diff --git a/tools/create_skia_google3_client.sh b/tools/create_skia_google3_client.sh
new file mode 100755
index 0000000000..8fbf4e2516
--- /dev/null
+++ b/tools/create_skia_google3_client.sh
@@ -0,0 +1,24 @@
+#!/bin/bash
+# Copyright 2014 Google Inc.
+#
+# Use of this source code is governed by a BSD-style license that can be
+# found in the LICENSE file.
+
+# Create a google3 CitC client in which code can be submitted to either google3
+# or Git.
+#
+# Usage:
+# ./tools/create_skia_google3_client.sh <client_name>
+
+source gbash.sh || exit
+
+set -x -e
+
+CLIENT="$1"
+g4 citc "${CLIENT}"
+cd "/google/src/cloud/${USER}/${CLIENT}/google3/third_party/skia/HEAD"
+
+REV="$(cat README.google | grep -e "^Version" | sed "s/^Version: \(.*\)/\1/")"
+
+MY_DIR="$(gbash::get_absolute_caller_dir)"
+${MY_DIR}/git_clone_to_google3.sh --skia_rev "${REV}"
diff --git a/tools/get_skia_lkgr.sh b/tools/get_skia_lkgr.sh
new file mode 100755
index 0000000000..1c38dd5c45
--- /dev/null
+++ b/tools/get_skia_lkgr.sh
@@ -0,0 +1,23 @@
+#!/bin/bash
+# Copyright 2014 Google Inc.
+#
+# Use of this source code is governed by a BSD-style license that can be
+# found in the LICENSE file.
+
+# Outputs the Last Known Good Revision of Skia.
+
+source gbash.sh || exit
+
+set -x -e
+
+# Retrieve last known good revision. (App-engine script is very flaky, so retry
+# 10 times.)
+LKGR=""
+for i in `seq 1 10`; do
+ LKGR=$(curl "http://skia-tree-status-staging.appspot.com/lkgr")
+ if [[ ${#LKGR} -gt 4 ]]; then
+ break
+ fi
+done
+[[ ${#LKGR} -gt 4 ]] || gbash::die "Unable to get Skia LKGR (got '${LKGR}')"
+echo "${LKGR}"
diff --git a/tools/git_clone_to_google3.sh b/tools/git_clone_to_google3.sh
new file mode 100755
index 0000000000..1e2f34f82d
--- /dev/null
+++ b/tools/git_clone_to_google3.sh
@@ -0,0 +1,94 @@
+#!/bin/bash
+# Copyright 2014 Google Inc.
+#
+# Use of this source code is governed by a BSD-style license that can be
+# found in the LICENSE file.
+
+# Crude script to clone the git skia repo into the current directory, which
+# must be a CitC client.
+#
+# Usage:
+# ./tools/git_clone_to_google3.sh
+
+source gbash.sh || exit
+DEFINE_string skia_rev "" "Git hash of Skia revision to clone, default LKGR."
+
+set -x -e
+
+# To run this script after making edits, run:
+# g4 revert -k git_clone_to_google3.sh
+# To get the file back into your CL, run:
+# g4 edit git_clone_to_google3.sh
+#g4 opened | grep -q "//depot" && gbash::die "Must run in a clean client."
+
+# Checkout LKGR of Skia in a temp location.
+TMP=$(gbash::make_temp_dir)
+pushd "${TMP}"
+git clone https://skia.googlesource.com/skia
+cd skia
+git fetch
+if [ -z "${FLAGS_skia_rev}" ]; then
+ # Retrieve last known good revision.
+ MY_DIR="$(gbash::get_absolute_caller_dir)"
+ FLAGS_skia_rev="$(${MY_DIR}/get_skia_lkgr.sh)"
+fi
+git checkout --detach "${FLAGS_skia_rev}"
+
+# Rsync to google3 location.
+popd
+# Use multichange client in case there are too many files for nomultichange. http://b/7292343
+g4 client --set_option multichange
+# Use allwrite to simplify opening the correct files after rsync.
+g4 client --set_option allwrite
+# Filter directories added to CitC.
+rsync -avzJ \
+ --delete \
+ --delete-excluded \
+ --include=/bench \
+ --include=/dm \
+ --include=/gm \
+ --include=/include \
+ --include=/src \
+ --exclude=/src/animator \
+ --include=/tests \
+ --include=/third_party \
+ --include=/tools \
+ --include=/.git \
+ '--exclude=/*/' \
+ --include=/third_party/etc1 \
+ --include=/third_party/ktx \
+ --include=/third_party/libwebp \
+ '--exclude=/third_party/*/' \
+ "${TMP}/skia/" \
+ "./"
+
+# Open added/changed files for add/edit.
+g4 reopen
+# Revert files that are equivalent to the checked in version.
+g4 revert -a
+
+# Tell CitC to ignore .git and .gitignore.
+find . \
+ \( -name .git \
+ -o -name .gitignore \
+ \) \
+ -execdir g4 revert -k \{\} \;
+
+# Tell Git to ignore README.google and BUILD.
+echo README.google >> .git/info/exclude
+echo BUILD >> .git/info/exclude
+g4 revert README.google
+g4 revert BUILD
+
+# Use google3 version of OWNERS, README.google, and BUILD.
+find . \
+ \( -name OWNERS -o -name README.google -o -name BUILD \) \
+ -exec git update-index --skip-worktree \{\} \; \
+ -execdir g4 revert \{\} \;
+
+# Tell git to ignore files left out of the rsync (i.e. "deleted" files).
+git status --porcelain | \
+ grep -e "^ D" | \
+ cut -c 4- | \
+ xargs git update-index --skip-worktree
+
diff --git a/tools/sync_google3.sh b/tools/sync_google3.sh
new file mode 100755
index 0000000000..50ad61c4a6
--- /dev/null
+++ b/tools/sync_google3.sh
@@ -0,0 +1,43 @@
+#!/bin/bash
+# Copyright 2014 Google Inc.
+#
+# Use of this source code is governed by a BSD-style license that can be
+# found in the LICENSE file.
+
+# Syncs //depot/google3/third_party/skia/HEAD to the last known good revision of
+# Skia. If this script is not run from a Piper client, creates a new CitC
+# client. Also updates README.google.
+#
+# Usage:
+# ./tools/sync_google3.sh
+
+source gbash.sh || exit
+
+set -x -e
+
+MY_DIR="$(gbash::get_absolute_caller_dir)"
+LKGR="$(${MY_DIR}/get_skia_lkgr.sh)"
+
+gbash::get_google3_dir && GOOGLE3="$(gbash::get_google3_dir)"
+if [ -z "${GOOGLE3}" ]; then
+ CLIENT_NAME="sync_skia_$(date '+%F-%H-%M-%S')"
+ ${MY_DIR}/create_skia_google3_client.sh "${CLIENT_NAME}"
+ GOOGLE3="/google/src/cloud/${USER}/${CLIENT_NAME}/google3"
+fi
+cd "${GOOGLE3}/third_party/skia/HEAD"
+${MY_DIR}/git_clone_to_google3.sh --skia-rev "${LKGR}"
+
+# Update README.google.
+sed --in-place "s/^Version: .*/Version: ${LKGR}/" README.google
+sed --in-place "s/URL: http:\/\/skia.googlesource.com\/skia\/+archive\/.*\.tar\.gz/URL: http:\/\/skia.googlesource.com\/skia\/+archive\/${LKGR}.tar.gz/" README.google
+CURRENT_DATE=`date '+%d %B %Y'`
+echo "Updated using sync_google3.sh on $CURRENT_DATE by $USER@google.com" >> README.google
+
+# Add README.google to the default change.
+g4 reopen
+# Create a new CL.
+CHANGE="$(g4 change --desc "Update skia HEAD to ${LKGR}.")"
+CL="$(echo "${CHANGE}" | sed "s/Change \([0-9]\+\) created.*/\1/")"
+
+# Run TAP.
+tap_presubmit -c "${CL}" -p skia